name: 'docker'

on:
  push:
    branches:
      - master

jobs:
  docker:
    runs-on: ubuntu-latest
    steps:
      - name: Checkout
        uses: actions/checkout@v2

      - name: Set up QEMU
        uses: docker/setup-qemu-action@v1

      - name: Set up Docker Buildx
        uses: docker/setup-buildx-action@v1

      - name: Inspect builder
        run: |
          echo "Name:      ${{ steps.buildx.outputs.name }}"
          echo "Endpoint:  ${{ steps.buildx.outputs.endpoint }}"
          echo "Status:    ${{ steps.buildx.outputs.status }}"
          echo "Flags:     ${{ steps.buildx.outputs.flags }}"
          echo "Platforms: ${{ steps.buildx.outputs.platforms }}"

      - name: Get Description
        id: get-info
        uses: actions/github-script@v6
        with:
          result-encoding: string
          script: |
            const commits = ${{ toJSON(github.event.commits) }}
            let all_commits="📜This image includes some of the following changes📜  "
            for (const commit of commits) {
              all_commits=all_commits.concat('📘', commit.message.split('\n')[0], ' ');
            }
            return all_commits

      - name: Docker label info
        id: docklabel
        run: |
          echo "::set-output name=ref::$GITHUB_REF_NAME"
          echo "::set-output name=sha::$GITHUB_SHA"
          echo "::set-output name=repo::$GITHUB_REPOSITORY"
          echo "::set-output name=timestamp::$(date '+%Y%m%d_%H%M%S')"

      - name: Login to GitHub Container Registry
        uses: docker/login-action@v1
        with:
          registry: ghcr.io
          username: ${{ github.actor }}
          password: ${{ secrets.GITHUB_TOKEN }}

      - name: Build and push
        uses: docker/build-push-action@v2
        with:
          context: .
          platforms: linux/386,linux/amd64,linux/arm64,linux/arm/v7,linux/arm/v6
          push: true
          tags: |
            ghcr.io/${{ steps.docklabel.outputs.repo }}:${{ steps.docklabel.outputs.timestamp }}
            ghcr.io/${{ steps.docklabel.outputs.repo }}
          labels: |
            org.opencontainers.image.revision=${{ steps.docklabel.outputs.sha }}
            org.opencontainers.image.description=${{ steps.get-info.outputs.result }}

      - name: Image digest
        run: echo ${{ steps.docker_build.outputs.digest }}
